#ifndef MAIN_H_INCL
#define MAIN_H_INCL

#include "libsdl.h"

namespace Main
{
	void Msg(const char *);
	[[noreturn]] void Exit();
	[[noreturn]] void Exit(const char *);
	int argc();
	const char *const *argv();

	class StateFunc
	{
	  public:
	  	using PtrType = StateFunc (*)();

		PtrType ptr;

		StateFunc() {}
		StateFunc(PtrType p)
		{
			ptr = (decltype (ptr)) p;
		}
		operator PtrType()
		{
			return ptr;
		}
	};
}

#endif